Attribute VB_Name = "modColorSB"
Option Explicit

' ---=== Const ===---
Private Const S_OK As Long = 0
Private Const GWL_WNDPROC As Long = -4
Private Const WM_CTLCOLORSCROLLBAR As Long = &H137

' ---=== Type ===---
Private Type ColorSB
    ScrollBar As Control
    hBrush As Long
End Type

' ---=== GDI32 Deklarationen ===---
Private Declare Function CreateSolidBrush Lib "gdi32" ( _
                         ByVal crColor As Long) As Long
                         
Private Declare Function DeleteObject Lib "gdi32" ( _
                         ByVal hObject As Long) As Long
                         
' ---=== USER32 Deklarationen ===---
Private Declare Function CallWindowProc Lib "user32" _
                         Alias "CallWindowProcA" ( _
                         ByVal lpPrevWndFunc As Long, _
                         ByVal hWnd As Long, _
                         ByVal Msg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long
                         
Private Declare Function SetWindowLong Lib "user32" _
                         Alias "SetWindowLongA" ( _
                         ByVal hWnd As Long, _
                         ByVal nIndex As Long, _
                         ByVal dwNewLong As Long) As Long
                         
' ---=== OLEOUT32 Deklarationen ===---
Private Declare Function OleTranslateColor Lib "oleaut32" ( _
                         ByVal lOleColor As Long, _
                         ByVal lHPalette As Long, _
                         ByRef lColorRef As Long) As Long
                         
' ---=== Variablen ===---
Private lngCount As Long
Private hFrmHwnd As Long
Private lngOldWndProc As Long
Private tColorSB() As ColorSB

Public Sub AddScrollBar(ByRef ScrollBar As Control, ByVal BackColor As Long)

    Dim lngItem As Long
    Dim bolAddItem As Boolean
    
    bolAddItem = True
    
    ' ist es eine horizontale oder vertikale Scrollbar
    If TypeOf ScrollBar Is HScrollBar Or TypeOf ScrollBar Is VScrollBar Then
    
        ' alle Element im Array tColorSB durchlaufen
        For lngItem = 0 To lngCount - 1
        
            ' ist eine Scrollbar gespeichert
            If Not tColorSB(lngItem).ScrollBar Is Nothing Then
            
                ' sind die Fensterhandle der Scrollbars gleich
                If tColorSB(lngItem).ScrollBar.hWnd = ScrollBar.hWnd Then
                
                    ' merken das diese Scrollbar schon existiert
                    bolAddItem = False
                    
                    ' Schleife verlassen
                    Exit For
                    
                End If
            End If
            
        Next lngItem
        
        ' wenn die Scrollbar noch nicht im Array existiert
        If bolAddItem Then
        
            ' Systemfarben konvertieren
            If OleTranslateColor(BackColor, 0&, BackColor) = S_OK Then
            
                ' Array tColorSB redimensionieren
                ReDim Preserve tColorSB(lngCount)
                
                ' Scrollbar speichern
                Set tColorSB(lngCount).ScrollBar = ScrollBar
                
                ' Brush fr diese Scrollbar erstellen
                tColorSB(lngCount).hBrush = CreateSolidBrush(BackColor)
                
                ' Anstelle von CreateSolidBrush kann auch jede andere Brush-API
                ' verwendet werden. So knnte man zb. mit CreatePatternBrush
                ' eine Bitmap als Hintergrund in eine Scrollbar setzen
                
                ' Zhler erhhen
                lngCount = lngCount + 1
                
                ' erneutes zeichnen fr diese Scrollbar anfordern
                tColorSB(lngCount - 1).ScrollBar.Refresh
                
            End If
        End If
    End If
    
End Sub

Public Sub RemoveScrollBar(ByRef ScrollBar As Control)

    Dim lngItem As Long
    Dim bolRemoveItem As Boolean
    
    bolRemoveItem = False
    
    ' ist es eine horizontale oder vertikale Scrollbar
    If TypeOf ScrollBar Is HScrollBar Or TypeOf ScrollBar Is VScrollBar Then
    
        ' alle Element im Array tColorSB durchlaufen
        For lngItem = 0 To lngCount - 1
        
            ' ist eine Scrollbar gespeichert
            If Not tColorSB(lngItem).ScrollBar Is Nothing Then
            
                ' sind die Fensterhandle der Scrollbars gleich
                If tColorSB(lngItem).ScrollBar.hWnd = ScrollBar.hWnd Then
                
                    ' merken das ab diesem Index umkopiert werden soll
                    bolRemoveItem = True
                    
                    ' gespeicherte Scrollbar lschen
                    Set tColorSB(lngItem).ScrollBar = Nothing
                    
                    ' ist ein Brush fr diese Scrollbar vorhanden
                    If tColorSB(lngItem).hBrush <> 0 Then
                    
                        ' Brush lschen
                        Call DeleteObject(tColorSB(lngItem).hBrush)
                        
                    End If
                    
                Else
                
                    ' wurde eine Scrollbar entfernt
                    If bolRemoveItem Then
                    
                        ' nchste Scrollbar an die freie Stelle umkopieren
                        Set tColorSB(lngItem - 1).ScrollBar = tColorSB(lngItem).ScrollBar
                        
                        ' gespeicherte Scrollbar lschen
                        Set tColorSB(lngItem).ScrollBar = Nothing
                        
                        ' ist ein Brush fr diese Scrollbar vorhanden
                        If tColorSB(lngItem).hBrush <> 0 Then
                        
                            ' Brusch an die freie Stelle umkopieren
                            tColorSB(lngItem - 1).hBrush = tColorSB(lngItem).hBrush
                            
                        End If
                    End If
                End If
            End If
            
        Next lngItem
        
        ' wurde eine Scrollbar entfernt
        If bolRemoveItem Then
        
            ' Zhler verkleinern
            lngCount = lngCount - 1
            
            ' Array tColorSB redimensionieren
            ReDim Preserve tColorSB(lngCount - 1)
            
            ' erneutes zeichnen fr die entfernte Scrollbar anfordern
            ScrollBar.Refresh
            
        End If
    End If
    
End Sub

Public Sub ChangeBackColor(ByRef ScrollBar As Control, ByVal BackColor As Long)

    Dim lngItem As Long
    
    ' ist es eine horizontale oder vertikale Scrollbar
    If TypeOf ScrollBar Is HScrollBar Or TypeOf ScrollBar Is VScrollBar Then
    
        ' alle Element im Array tColorSB durchlaufen
        For lngItem = 0 To lngCount - 1
        
            ' ist eine Scrollbar gespeichert
            If Not tColorSB(lngItem).ScrollBar Is Nothing Then
            
                ' sind die Fensterhandle der Scrollbars gleich
                If tColorSB(lngItem).ScrollBar.hWnd = ScrollBar.hWnd Then
                
                    ' ist ein Brush fr diese Scrollbar vorhanden
                    If tColorSB(lngItem).hBrush <> 0 Then
                    
                        ' alten Brush von dieser Scrollbar lschen
                        Call DeleteObject(tColorSB(lngItem).hBrush)
                        
                        ' Systemfarben konvertieren
                        If OleTranslateColor(BackColor, 0&, BackColor) = S_OK Then
                        
                            ' neuen Brush fr diese Scrollbar erstellen
                            tColorSB(lngItem).hBrush = CreateSolidBrush(BackColor)
                            
                            ' erneutes zeichnen fr diese Scrollbar anfordern
                            tColorSB(lngItem).ScrollBar.Refresh
                            
                        End If
                    End If
                    
                    ' Schleife verlassen
                    Exit For
                    
                End If
            End If
            
        Next lngItem
        
    End If
    
End Sub

Public Sub Hook(ByRef Frm As Form)

    ' Fensterhandle speichern
    hFrmHwnd = Frm.hWnd
    
    ' Subclassing der Form starten
    lngOldWndProc = SetWindowLong(hFrmHwnd, GWL_WNDPROC, AddressOf WindowProc)
    
End Sub

Public Sub Unhook()

    Dim lngItem As Long
    
    ' Subclassing der Form beenden
    Call SetWindowLong(hFrmHwnd, GWL_WNDPROC, lngOldWndProc)
    
    ' alle Element im Array tColorSB durchlaufen
    For lngItem = 0 To lngCount - 1
    
        ' gespeicherte Scrollbar lschen
        Set tColorSB(lngItem).ScrollBar = Nothing
        
        ' ist ein Brush fr diese Scrollbar vorhanden
        If tColorSB(lngItem).hBrush <> 0 Then
        
            ' Brush lschen
            Call DeleteObject(tColorSB(lngItem).hBrush)
            
        End If
        
    Next lngItem
    
    ' Array tColorSB lschen
    Erase tColorSB
    
End Sub

Private Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As _
    Long, ByVal lParam As Long) As Long
    
    Dim lngItem As Long
    
    ' Nur wenn die Nachricht WM_CTLCOLORSCROLLBAR eintrifft die fr das
    ' zeichnen der Hintergrundfarbe in Scrollbar-Steuerelementen verantwortlich ist.
    If uMsg = WM_CTLCOLORSCROLLBAR Then
    
        ' alle Element im Array tColorSB durchlaufen
        For lngItem = 0 To lngCount - 1
        
            ' ist eine Scrollbar gespeichert
            If Not tColorSB(lngItem).ScrollBar Is Nothing Then
        
                ' ist das Fensterhandle der Scrollbar = lParam
                If tColorSB(lngItem).ScrollBar.hWnd = lParam Then
            
                    ' ist fr diese Scrollbar ein Brush vorhanden
                    If tColorSB(lngItem).hBrush <> 0 Then
                
                        ' Handle des Brush an die Funktion bergeben
                        ' damit wird die Hintergrundfarbe der Scrollbar gesetzt
                        WindowProc = tColorSB(lngItem).hBrush
                    
                        ' Schleife verlassen
                        Exit For
                    
                    End If
                End If
            End If
        Next lngItem
        
    Else
    
        ' alle anderen Nachrichten weiterleiten
        WindowProc = CallWindowProc(lngOldWndProc, hWnd, uMsg, wParam, lParam)
        
    End If
    
End Function
